﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package 
{
	import commande.MacroCommande;
	import commande.LampeOff;
	import commande.LampeOn;
	import commande.ICommande;
	import commande.Lampe;
	import commande.Telecommande;

	import com.actionscriptfacile.ui.text.UITextField;
	import com.as3facile.DefaultButton;
	import flash.events.MouseEvent;


	import flash.display.Sprite;
	import flash.events.Event;

	import com.demonsters.debugger.MonsterDebugger;


	/**
	 * Exemple d'utilisation du modèle de conception Observer.
	 * 
	 * 
	 * 
	 * @author Matthieu
	 */
	public class Main extends Sprite 
	{
		private var nPosX : Number;// position du champ texte
		private var nPosY : Number;// position du champ texte
		

		
		public function Main() 
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}


		/**
		 * Démarrage de l'application.
		 * 
		 */
		protected function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
            MonsterDebugger.initialize(this);
            MonsterDebugger.trace(this, "Modele de conception : Command");		
								
			// construction de la page
			this.setupUI();	
		}
		
		
		
		/**
		 * Création d'un bouton pour le pattern Decorator.
		 * 
		 */
		private function setupUI():void
		{
			nPosX = 30;
			nPosY = 15;
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "Lancez Commande !";
			oBtnStart.getObject().x = nPosX;
			oBtnStart.getObject().y = nPosY;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onRunCommand );
			this.addChild(oBtnStart);	
			
			nPosY += 50;
		}
		
		
		/**
		 * Après le click sur le bouton.
		 * 
		 */
		private function onRunCommand(e : MouseEvent) : void 
		{
			this.removeEventListener(MouseEvent.CLICK, onRunCommand);


			var sTxt1:String = "Création de la Télécommande";
			MonsterDebugger.trace(this, sTxt1);
			var oText1:UITextField = this.addText( sTxt1, nPosX, nPosY);
			nPosY += 32;
			this.addChild(oText1);
			
			
			/* test de notre télécommande */
			var oTelecommande:Telecommande = new Telecommande();
			
			// création des lampes
			var oLampeCuisine:Lampe = new Lampe("Cuisine");
			var oLampeSejour:Lampe = new Lampe("Séjour");
			var oLampeChambre:Lampe = new Lampe("Chambre");
			
			// création des objets commandes de lampes (les interrupteurs)
			var oCmdLampeOnCuisine:ICommande = new LampeOn(oLampeCuisine);
			var oCmdLampeOffCuisine:ICommande = new LampeOff(oLampeCuisine);
			
			var oCmdLampeOnSejour:ICommande = new LampeOn(oLampeSejour);
			var oCmdLampeOffSejour:ICommande = new LampeOff(oLampeSejour);
			
			var oCmdLampeOnChambre:ICommande = new LampeOn(oLampeChambre);
			var oCmdLampeOffChambre:ICommande = new LampeOff(oLampeChambre);
			
			// chargement des commandes dans la télécommande
			oTelecommande.addCommande(0, oCmdLampeOnSejour, oCmdLampeOffSejour);
			oTelecommande.addCommande(1, oCmdLampeOnCuisine, oCmdLampeOffCuisine);
			oTelecommande.addCommande(2, oCmdLampeOnChambre, oCmdLampeOffChambre);
			
			var oText2:UITextField = this.addText( sTxt1, nPosX, nPosY);
			nPosY += 32;
			this.addChild(oText2);
			
			// allume et éteind les différentes lampes
			oTelecommande.onBtnOn(0);
			oTelecommande.onBtnOn(1);
			oTelecommande.onBtnOn(2);
			
			oTelecommande.onBtnOff(2);
			oTelecommande.onBtnOff(1);
			oTelecommande.onBtnOff(0);
			
			MonsterDebugger.trace(this, "Bouton Annuler");
			oTelecommande.onBtnAnnuler();
			
			oTelecommande.onBtnOn(2);
			
			// création d'une MacroCommande
			var aAllumeAll:Array = [oCmdLampeOnCuisine, oCmdLampeOnSejour, oCmdLampeOnChambre];
			var aEteindAll:Array = [oCmdLampeOffCuisine, oCmdLampeOffSejour, oCmdLampeOffChambre];
			
			var oAllumeAll:ICommande = new MacroCommande(aAllumeAll);		
			var oEteindAll:ICommande = new MacroCommande(aEteindAll);	
			
			oTelecommande.addCommande(3, oAllumeAll, oEteindAll);// ajout de la MacroCommande
			MonsterDebugger.trace(this, "MacroCommande");
			oTelecommande.onBtnOff(3);// exécution du groupe de Commande (la MacroCommande)
			oTelecommande.onBtnAnnuler();	
			
		}
	
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String, nX:Number, nY:Number) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeNone();
			
			oTxtField.wordWrap = true;
			//oTxtField.multiline = true;// plusieurs lignes dans le champ texte
			oTxtField.maxHeight = oTxtField.height = 26;
			oTxtField.maxWidth = oTxtField.width = 450;
			
			oTxtField.x = nX;
			oTxtField.y = nY;
			
			oTxtField.background = true;
			oTxtField.backgroundColor = 0xcccccc;
			
			oTxtField.changeFormat("size", 15);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", Math.random() *0X006f77);// changement de la couleur
			
			return oTxtField;	 	 
		}
	}
}
