/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package commande
{

	import com.demonsters.debugger.MonsterDebugger;
	import flash.utils.getQualifiedClassName;
	
	
	/**
	 * @author Matthieu
	 * La télécommande gère plusieur commandes marche ou arrêt.
	 * 
	 */
	public class Telecommande
	{
		// tableaux contenant les commandes
		private var aTurnOn:Array;// la liste des boutons (commandes) marche - on
		private var aTurnOff:Array;// la liste des boutons (commandes) arrêt - off
		
		private var oCmdAnnuler:ICommande;// pour le bouton annuler - lance la commande d'annulation


		/**
		 * constructeur.
		 * 
		 */
		public function Telecommande()
		{
			aTurnOn = new Array();
			aTurnOff = new Array();
			
			/**
			 * PasDeCommande est un Objet Null pour éviter d'ajouter un test avant d'appeler la méthode execute.
			 * L'utilisation d'un Objet Null est utilisé dans de nombreux modèle de conception.
			 * Cela permet de simplifier et d'optimiser le code.
			 */			
			var oCommande:PasDeCommande = new PasDeCommande();
			
			// initialisation par défaut de tous les boutons
			for (var i : int = 0; i < 7; i++) // il y a 7 boutons différents sur notre télécommande
			{
				aTurnOff[i] = oCommande; 	
				aTurnOn[i] = oCommande; 	
			}
			oCmdAnnuler = oCommande;
		}
		
		

		/**
		 * Ajout d'une commande.
		 * Permet de configurer un bouton de la télécommande.
		 * 
		 * @param nPos : la position du bouton
		 * @param oOn : la commande marche
		 * @param oOff : la commande arrêt
		 * 
		 */
		public function addCommande(nPos:int, oOn:ICommande, oOff:ICommande) : void
		{			
			aTurnOn[nPos] = oOn;
			aTurnOff[nPos] = oOff;
		}
		

		/**
		 * Appuie sur le bouton marche
		 * 
		 */
		public function onBtnOn(nPos:int) : void
		{
			aTurnOn[nPos].execute();// Appel sur l'objet sa méthode execute()
			oCmdAnnuler = aTurnOn[nPos];// mémorise la dernière commande exécutée		
		}
		
	
		/**
		 * Appuie sur le bouton arrêt.
		 * 
		 */
		public function onBtnOff(nPos:int) : void
		{
			aTurnOff[nPos].execute();// Appel sur l'objet sa méthode execute()
			oCmdAnnuler = aTurnOff[nPos];// mémorise la dernière commande exécutée		
		}
		
		
		/**
		 * L'utilisateur appuie sur le bouton annuler de la télécommande.
		 * 
		 */
		public function onBtnAnnuler() : void
		{
			oCmdAnnuler.callBack();// exécute la commande d'annulation du bouton
		}

		
		/**
		 * Renvoie une représentation de la classe sous forme de caractères.
		 * 
		 */
		public function toStringe() : String 
		{
			MonsterDebugger.trace(this, "toString");
			var sOutput:String = "commande.Telecommande";
			
			//sOutput += "\n\n";
			MonsterDebugger.trace(this, "sOutput "+sOutput);
			for (var i : int = 0; i < aTurnOn.length; i++) 
			{
				sOutput += "emplacement : "+ getQualifiedClassName(aTurnOn[i])+" arrêt : "+getQualifiedClassName(aTurnOff[i])+"\n";
			}
			return sOutput;
		}
	}
}
